public class Card implements Comparable {
	public static final String SPADE = "Spade";
	public static final String HEART = "Heart";
	public static final String CLUB = "Club";
	public static final String DIAMOND = "Diamond";
	
	private int value;  //2 = 2, Jack = 11, Queen = 12, King = 13, Ace = 14
	private String suit;
	
	public Card(int value, String suit) {
		this.value = value;
		this.suit = suit;		
	}
	
	public String getSuit() {
		return suit;
	}
	
	public int getValue() {
		return value;
	}
	
	//Cards are arranged in a sorted Collection from highest card first down to lowest card
	//Order is imposed on suit too, so that duplicates cannot be inserted. The ordering on suit is not used in the gameplay however
	public int compareTo(Object o) {
		assert o instanceof Card;
		Card card = (Card) o;
		int cValue = card.getValue();
		String cSuit = card.getSuit();
		if(getValue() < cValue) {
			return 1;
		} else if(getValue() > cValue) {
			return -1;
		} else if(getSuit().equals(cSuit)) {
			return 0;
		} else {  //Order: Spade, Heart, Club, Diamond
			if(getSuit().equals(DIAMOND)) {
				return 1;
			} else if(getSuit().equals(SPADE)) {
				return -1;
			} else if(getSuit().equals(HEART) && !cSuit.equals(SPADE)) {
				return -1;
			} else if(cSuit.equals(SPADE)) {
				return 1;
			} else if(getSuit().equals(CLUB) && !cSuit.equals(DIAMOND)) {
				return 1;
			} else if(cSuit.equals(DIAMOND)) {
				return -1;
			}
			return 0;
		}
	}

}
