
public class CashGame extends PokerGame {

	private Dealer cashDealer;
        
        protected CashGame() {
            setBigBlind(0.20);
            setSmallBlind(0.10);
            setAnte(0);
        }
	
	public void initGame() {
		PokerStyleFactory factory = getPokerStyleFactory();
		Table table = factory.createTable("CashTable1");
		cashDealer = factory.createDealer("CashDealer1");
		cashDealer.setTable(table);
                table.setDealer(cashDealer);
                TableGui gui = TableGui.getTableGui();
                gui.setTable(table);
		for(int i = 1; i <= Table.MAX_PLAYERS; i++) {
                    Player player = factory.createPlayer("Player" + i, "Player" + i, 20.0);
                    PlayerHand pHand = player.getPlayerHand();
                    table.addPlayerHand(pHand);
		}
                gui.setPlayers(table.getPlayers());
	}

	public void run() {
            cashDealer.startHand(getAnte(), getSmallBlind(), getBigBlind());
	}

}
