
public abstract class Player {
	private String name;
	private String id;  //id must be unique for each Player
	private double chips;
	private PlayerHand playerHand;
	
	public Player(String name, String id, double chips) {
		setName(name);
		setId(id);
		setChips(chips);
		playerHand = new PlayerHand(this);
	}
	
        public PotContribution bet(double amount, boolean forced) {
            TableGui gui = TableGui.getTableGui();
            double potCont = amount;
            boolean allIn = false;
            if(getChips() - amount <= 0) {
		potCont = getChips();
                allIn = true;
            }
            removeChips(potCont);
            gui.updatePlayerChips();
            return new PotContribution(this, potCont, allIn, forced);
        }
        
        public void muckPlayerHand() {
            getPlayerHand().setMucked(true);            
        }
        
	public String getName() {
		return name;
	}
        
        private void setName(String name) {
            this.name = name;
        }
	
	public String getId() {
		return id;
	}
        
        private void setId(String id) {
            this.id = id;
        }
        
	
	public double getChips() {
		return chips;
	}
	
	private void setChips(double chips) {
		this.chips = chips;
	}
	
	private void removeChips(double chips) {
		double diff = getChips() - chips;
		if(diff < 0)
			diff = 0;  //cannot have negative chips
		setChips(diff);
	}
	
	public PlayerHand getPlayerHand() {
		return playerHand;
	}
	
	public void setPlayerHand(PlayerHand pH) {
		playerHand = pH;
	}
        
        //Players are equal if they have the same ID
        public boolean equals(Object o) {
            if(o instanceof Player) {
		Player player = (Player) o;
		return player.getId().equals(getId());
            }
            else {
		return false;
            }
	}
        
        public int hashCode() {
		return getId().hashCode();
	}
	
}
