
public abstract class PokerStyleFactory {
	
	public PokerStyleFactory() {
		
	}
	
	public abstract Player createPlayer(String name, String id, double chips);
	//createPlayer() creates an equivalent PokerHand for that player. This means that clients do not have to worry...
	//...about setting up the two-way composition relationship between Player and PlayerHand
	public abstract Dealer createDealer(String name);
	
	//createTable is here to try to enforce that a new Table has to be created when the PokerStyleFactory changes, so we...
	//...don't run into having DrawDealers at the same Table as HoldEmPlayers etc
	public Table createTable(String id) {
		return new Table(id);
	}
	
}
