
public class PotContribution {
    
    private Player player;
    private double amount;
    private boolean allIn;
    private boolean forced;  //blinds and antes are forced
    private boolean complete;  //complete for that betting round
    private boolean mucked;  //if the equivalent PlayerHand is mucked
    
    public PotContribution(Player player, double amount, boolean allIn, boolean forced) {
        this.player = player;
        setAmount(amount);
        setAllIn(allIn);
        setForced(forced);  //if true, the player still has a chance to bet before the round is deemed finished by the Dealer
        setComplete(false);
        setMucked(false);
    }
    
    public Player getPlayer() {
        return player;
    }
    
    public double getAmount() {
        return amount;
    }
    
    public void setAmount(double amount) {
        this.amount = amount;
    }
    
    public boolean getForced() {
        return forced;
    }
    
    public void setForced(boolean forced) {
        this.forced = forced;
    }
    
    public boolean getAllIn() {
        return allIn;
    }
    
    public void setAllIn(boolean allIn) {
        this.allIn = allIn;
    }
    
    public boolean getComplete() {
        return complete;
    }
    
    public void setComplete(boolean complete) {
        this.complete = complete;
    }
    
    public boolean getMucked() {
        return mucked;
    }
    
    public void setMucked(boolean mucked) {
        this.mucked = mucked;
    }
    
    //PotContributions are equal if they have the same Player and both are incomplete
    public boolean equals(Object o) {
	if(o instanceof PotContribution) {
            PotContribution pC = (PotContribution) o;
            Player pl = pC.getPlayer();
            if(pl.equals(getPlayer()) && pC.getComplete() == getComplete())
                return true;
        }
        return false;
    }
	
    public int hashCode() {
        return getPlayer().hashCode();
    }
    
}
